Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/lscp_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/lscp_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/lscp_mod.F90	(revision 4482)
@@ -1,3 +1,3 @@
-MODULE LSCP_mod
+MODULE lscp_mod
 
 IMPLICIT NONE
@@ -6,13 +6,14 @@
 
 !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-SUBROUTINE LSCP(dtime,missing_val,                      &
+SUBROUTINE lscp(klon,klev,dtime,missing_val,            &
      paprs,pplay,t,q,ptconv,ratqs,                      &
-     d_t, d_q, d_ql, d_qi, rneb, rneb_seri,             &
-     radliq, radicefrac, rain, snow,                    &
-     pfrac_impa, pfrac_nucl, pfrac_1nucl,               &
+     d_t, d_q, d_ql, d_qi, rneb, rneblsvol, rneb_seri,  &
+     radocond, radicefrac, rain, snow,                    &
      frac_impa, frac_nucl, beta,                        &
      prfl, psfl, rhcl, zqta, fraca,                     &
      ztv, zpspsk, ztla, zthl, iflag_cld_th,             &
-     iflag_ice_thermo, ok_ice_sursat)
+     iflag_ice_thermo, ok_ice_sursat, qsatl, qsats,     &
+     qclr, qcld, qss, qvc, rnebclr, rnebss, gamma_ss,   &
+     Tcontr, qcontr, qcontr2, fcontrN, fcontrP)
 
 !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@ -23,10 +24,10 @@
 !--------------------------------------------------------------------------------
 ! Aim: Large Scale Clouds and Precipitation (LSCP)
-!      
+!
 ! This code is a new version of the fisrtilp.F90 routine, which is itself a 
 ! merge of 'first' (superrsaturation physics, P. LeVan K. Laval)
 ! and 'ilp' (il pleut, L. Li)
 !
-! Compared to fisrtilp, LSCP 
+! Compared to the original fisrtilp code, lscp
 ! -> assumes thermcep = .TRUE. all the time (fisrtilp inconsistent when .FALSE.)
 ! -> consider always precipitation thermalisation (fl_cor_ebil>0)
@@ -40,20 +41,21 @@
 ! References: 
 !
+! - Bony, S., & Emanuel, K. A. 2001, JAS, doi: 10.1175/1520-0469(2001)058<3158:APOTCA>2.0.CO;2
 ! - Hourdin et al. 2013, Clim Dyn, doi:10.1007/s00382-012-1343-y
 ! - Jam et al. 2013, Boundary-Layer Meteorol, doi:10.1007/s10546-012-9789-3
+! - Jouhaud, et al. 2018. JAMES, doi:10.1029/2018MS001379
 ! - Madeleine et al. 2020, JAMES, doi:10.1029/2020MS002046
+! - Touzze-Peifert Ludo, PhD thesis, p117-124
 ! -------------------------------------------------------------------------------
 ! Code structure:
 !
-! P0>     Thermalization of the  precipitation coming from the overlying layer
+! P0>     Thermalization of the precipitation coming from the overlying layer
 ! P1>     Evaporation of the precipitation (falling from the k+1 level)
 ! P2>     Cloud formation (at the k level) 
-! P2.A.0> Cloud properties calculation from a rectangular pdf
-! P2.A.1> With the new PDFs, calculation of cloud properties using the inital
+! P2.A.1> With the PDFs, calculation of cloud properties using the inital
 !         values of T and Q
 ! P2.A.2> Coupling between condensed water and temperature
 ! P2.A.3> Calculation of final quantities associated with cloud formation
-! P2.B>   'All or nothing' cloud
-! P2.C>   Release of Latent heat after cloud formation
+! P2.B>   Release of Latent heat after cloud formation
 ! P3>     Autoconversion to precipitation (k-level)
 ! P4>     Wet scavenging
@@ -64,5 +66,5 @@
 ! water used in the physics and the dynamics 
 ! 
-! During the autoconversion to precipitation (P3 step), radliq (cloud water used
+! During the autoconversion to precipitation (P3 step), radocond (cloud water used
 ! by the radiation scheme) is calculated as an average of the water that remains
 ! in the cloud during the precipitation and not the water remaining at the end
@@ -74,63 +76,56 @@
 ! Radiation:
 ! xflwc(newmicro)+xfiwc(newmicro) =
-!   cldliq(physiq)=radliq(fisrt)=lwcon(nc)+iwcon(nc)
-!
-! Physics/Dynamics:
-! ql_seri(physiq)+qs_seri(physiq)=ocond(nc)
+!   radocond=lwcon(nc)+iwcon(nc)
 !
 ! Notetheless, be aware of:
 !
-! radliq(fisrt) .NE. ocond(nc)
+! radocond .NE. ocond(nc)
 ! i.e.:
 ! lwcon(nc)+iwcon(nc) .NE. ocond(nc)
+! but oliq+(ocond-oliq) .EQ. ocond
 ! (which is not trivial)
 !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-  
-USE dimphy
+!
 USE print_control_mod, ONLY: prt_level, lunout
-USE cloudth_mod 
-USE ioipsl_getin_p_mod, ONLY : getin_p
-USE phys_local_var_mod, ONLY: ql_seri,qs_seri
-USE phys_local_var_mod, ONLY: rneblsvol
-USE lscp_tools_mod, ONLY : CALC_QSAT_ECMWF, ICEFRAC_LSCP, CALC_GAMMASAT, FALLICE_VELOCITY
-USE ice_sursat_mod
-!--ice supersaturation
-USE phys_local_var_mod, ONLY: zqsats, zqsatl
-USE phys_local_var_mod, ONLY: qclr, qcld, qss, qvc, rnebclr, rnebss, gamma_ss
-USE phys_local_var_mod, ONLY: Tcontr, qcontr, qcontr2, fcontrN, fcontrP
+USE cloudth_mod, ONLY : cloudth, cloudth_v3, cloudth_v6, cloudth_mpc 
+USE lscp_tools_mod, ONLY : calc_qsat_ecmwf, icefrac_lscp, calc_gammasat, fallice_velocity
+USE ice_sursat_mod, ONLY : ice_sursat
+
+USE lscp_ini_mod, ONLY : seuil_neb, ninter, iflag_evap_prec, t_coup, DDT0, ztfondue, rain_int_min
+USE lscp_ini_mod, ONLY : iflag_mpc_bl, ok_radocond_snow, a_tr_sca, ok_debug_autoconversion
+
 
 IMPLICIT NONE
 
 !===============================================================================
-! VARIABLE DECLARATION
+! VARIABLES DECLARATION
 !===============================================================================
 
 include "YOMCST.h"
 include "YOETHF.h"
-include "FCTTRE.h"
 include "fisrtilp.h"
 include "nuage.h" 
 
-  
 ! INPUT VARIABLES:
 !-----------------
 
+  INTEGER,                         INTENT(IN)   :: klon,klev       ! number of horizontal grid points and vertical levels
   REAL,                            INTENT(IN)   :: dtime           ! time step [s]
-  REAL, INTENT(IN)                              :: missing_val     ! missing value for output
+  REAL,                            INTENT(IN)   :: missing_val     ! missing value for output
 
   REAL, DIMENSION(klon,klev+1),    INTENT(IN)   :: paprs           ! inter-layer pressure [Pa]
   REAL, DIMENSION(klon,klev),      INTENT(IN)   :: pplay           ! mid-layer pressure [Pa]
   REAL, DIMENSION(klon,klev),      INTENT(IN)   :: t               ! temperature (K)
-  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: q               ! specific humidity [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: q               ! total specific humidity (= vapor phase) [kg/kg] 
   INTEGER,                         INTENT(IN)   :: iflag_cld_th    ! flag that determines the distribution of convective clouds
   INTEGER,                         INTENT(IN)   :: iflag_ice_thermo! flag to activate the ice thermodynamics
-                                                                   ! CR: if iflag_ice_thermo=2, only convection is active    
+                                                                   ! CR: if iflag_ice_thermo=2, only convection is active
   LOGICAL,                         INTENT(IN)   :: ok_ice_sursat   ! flag to determine if ice sursaturation is activated
 
   LOGICAL, DIMENSION(klon,klev),   INTENT(IN)   :: ptconv          ! grid points where deep convection scheme is active
 
-  
+
   !Inputs associated with thermal plumes
-  
+
   REAL, DIMENSION(klon,klev),      INTENT(IN)   :: ztv             ! virtual potential temperature [K]
   REAL, DIMENSION(klon,klev),      INTENT(IN)   :: zqta            ! specific humidity within thermals [kg/kg]
@@ -144,6 +139,6 @@
 
   REAL, DIMENSION(klon,klev),      INTENT(INOUT):: ratqs            ! function of pressure that sets the large-scale
-                                                                    ! cloud PDF (sigma=ratqs*qt)
-  
+  REAL, DIMENSION(klon,klev),      INTENT(INOUT):: beta             ! conversion rate of condensed water
+
 
   ! Input sursaturation en glace
@@ -158,19 +153,15 @@
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: d_qi             ! cloud ice mass increment [kg/kg]
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: rneb             ! cloud fraction [-]
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: radliq           ! condensed water used in the radiation scheme [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: rneblsvol        ! cloud fraction per unit volume [-]  
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: radocond         ! condensed water used in the radiation scheme [kg/kg]
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: radicefrac       ! ice fraction of condensed water for radiation scheme
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: rhcl             ! clear-sky relative humidity [-]
-  REAL, DIMENSION(klon),           INTENT(OUT)  :: rain             ! large-scale rainfall [kg/s/m2] 
-  REAL, DIMENSION(klon),           INTENT(OUT)  :: snow             ! large-scale snowfall [kg/s/m2]
+  REAL, DIMENSION(klon),           INTENT(OUT)  :: rain             ! surface large-scale rainfall [kg/s/m2] 
+  REAL, DIMENSION(klon),           INTENT(OUT)  :: snow             ! surface large-scale snowfall [kg/s/m2]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qsatl            ! saturation specific humidity wrt liquid [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qsats            ! saturation specific humidity wrt ice [kg/kg]  
   REAL, DIMENSION(klon,klev+1),    INTENT(OUT)  :: prfl             ! large-scale rainfall flux in the column [kg/s/m2]
   REAL, DIMENSION(klon,klev+1),    INTENT(OUT)  :: psfl             ! large-scale snowfall flux in the column [kg/s/m2]
 
- 
-  ! cofficients of scavenging fraction (for off-line)
- 
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: pfrac_nucl       ! scavenging fraction due tu nucleation [-]
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: pfrac_1nucl      ! scavenging fraction due tu nucleation with a -1 factor [-]
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: pfrac_impa       ! scavening fraction due to impaction [-]
-  
   ! fraction of aerosol scavenging through impaction and nucleation (for on-line)
   
@@ -178,39 +169,22 @@
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: frac_nucl        ! scavenging fraction due tu nucleation [-]
   
-
-
-
-  ! PROGRAM PARAMETERS:
-  !--------------------
+  ! for supersaturation and contrails parameterisation
   
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qclr             ! specific total water content in clear sky region [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qcld             ! specific total water content in cloudy region [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qss              ! specific total water content in supersat region [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qvc              ! specific vapor content in clouds [kg/kg] 
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: rnebclr          ! mesh fraction of clear sky [-]   
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: rnebss           ! mesh fraction of ISSR [-]  
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: gamma_ss         ! coefficient governing the ice nucleation RHi threshold [-]      
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: Tcontr           ! threshold temperature for contrail formation [K]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qcontr           ! threshold humidity for contrail formation [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qcontr2          ! // (2nd expression more consistent with LMDZ expression of q)          
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: fcontrN          ! fraction of grid favourable to non-persistent contrails
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: fcontrP          ! fraction of grid favourable to persistent contrails
   
-  REAL, SAVE :: seuil_neb=0.001                                     ! cloud fraction threshold: a cloud really exists when exceeded
-  !$OMP THREADPRIVATE(seuil_neb)
-
-  INTEGER, SAVE :: ninter=5                                         ! number of iterations to calculate autoconversion to precipitation
-  !$OMP THREADPRIVATE(ninter)
-
-  INTEGER,SAVE :: iflag_evap_prec=1                                 ! precipitation evap. flag. 0: nothing, 1: "old way", 2: Max cloud fraction above to calculate the max of reevaporation
-                                                                    ! 4: LTP'method i.e. evaporation in the clear-sky fraction of the mesh only
-  !$OMP THREADPRIVATE(iflag_evap_prec)
-                                                                    
-
-  REAL t_coup                                                       ! temperature threshold which determines the phase 
-  PARAMETER (t_coup=234.0)                                          ! for which the saturation vapor pressure is calculated
-
-  REAL DDT0                                                         ! iteration parameter 
-  PARAMETER (DDT0=.01)
-
-  REAL ztfondue                                                     ! parameter to calculate melting fraction of precipitation
-  PARAMETER (ztfondue=278.15)
-
-  REAL, SAVE    :: rain_int_min=0.001                               ! Minimum local rain intensity [mm/s] before the decrease in associated precipitation fraction 
-  !$OMP THREADPRIVATE(rain_int_min)
-
-
 
   ! LOCAL VARIABLES:
   !----------------
-
 
   REAL qsl(klon), qsi(klon)
@@ -218,12 +192,12 @@
   REAL ctot(klon,klev)
   REAL ctot_vol(klon,klev)
-  REAL zqs(klon), zdqs(klon), zdelta, zcor, zcvm5  
+  REAL zqs(klon), zdqs(klon), zdelta, zcor, zcvm5
   REAL zdqsdT_raw(klon)
-  REAL gammasat(klon),dgammasatdt(klon)                                 ! coefficient to make cold condensation at the correct RH and derivative wrt T
+  REAL gammasat(klon),dgammasatdt(klon)                ! coefficient to make cold condensation at the correct RH and derivative wrt T
   REAL Tbef(klon),qlbef(klon),DT(klon),num,denom
   REAL cste
   REAL zpdf_sig(klon),zpdf_k(klon),zpdf_delta(klon)
   REAL Zpdf_a(klon),zpdf_b(klon),zpdf_e1(klon),zpdf_e2(klon)
-  REAL erf   
+  REAL erf
   REAL qcloud(klon), icefrac_mpc(klon,klev), qincloud_mpc(klon)
   REAL zrfl(klon), zrfln(klon), zqev, zqevt 
@@ -245,38 +219,28 @@
   ! Variables precipitation energy conservation
   REAL zmqc(klon)
-  ! Variables for tracers
-  ! temporary: alpha parameter for scavenging
-  ! 4 possible scavenging processes
-  REAL a_tr_sca(4)
-  save a_tr_sca
-  !$OMP THREADPRIVATE(a_tr_sca)  
   REAL zalpha_tr
   REAL zfrac_lessi
   REAL zprec_cond(klon)
-  REAL beta(klon,klev)                   ! conversion rate of condensed water
   REAL zmair(klon), zcpair, zcpeau
   REAL zlh_solid(klon), zm_solid         ! for liquid -> solid conversion
-  REAL zrflclr(klon), zrflcld(klon)                                                                    
-  REAL d_zrfl_clr_cld(klon), d_zifl_clr_cld(klon)                                                   
+  REAL zrflclr(klon), zrflcld(klon)
+  REAL d_zrfl_clr_cld(klon), d_zifl_clr_cld(klon)
   REAL d_zrfl_cld_clr(klon), d_zifl_cld_clr(klon) 
-  REAL ziflclr(klon), ziflcld(klon)                                                                    
-  REAL znebprecipclr(klon), znebprecipcld(klon)                                                        
-  REAL tot_zneb(klon), tot_znebn(klon), d_tot_zneb(klon)                                              
+  REAL ziflclr(klon), ziflcld(klon)
+  REAL znebprecipclr(klon), znebprecipcld(klon)
+  REAL tot_zneb(klon), tot_znebn(klon), d_tot_zneb(klon)
   REAL d_znebprecip_clr_cld(klon), d_znebprecip_cld_clr(klon)
   REAL velo(klon,klev), vr
   REAL qlmpc, qimpc, rnebmpc
-  REAL radliqi(klon,klev), radliql(klon,klev)
+  REAL radocondi(klon,klev), radocondl(klon,klev)
 
   INTEGER i, k, n, kk
   INTEGER n_i(klon), iter
-  INTEGER ncoreczq  
+  INTEGER ncoreczq
   INTEGER mpc_bl_points(klon,klev)
-  INTEGER,SAVE :: itap=0
-  !$OMP THREADPRIVATE(itap)
 
   LOGICAL lognormale(klon)
-  LOGICAL convergence(klon)
-  LOGICAL appel1er
-  SAVE appel1er
+  LOGICAL keepgoing(klon)
+  LOGICAL,SAVE :: appel1er
   !$OMP THREADPRIVATE(appel1er)
 
@@ -290,5 +254,5 @@
 !===============================================================================
 
-! Few initial checksS
+! Few initial checks
 
 IF (iflag_t_glace.EQ.0) THEN
@@ -302,74 +266,30 @@
 ENDIF
 
-IF (.NOT.thermcep) THEN
-     abort_message = 'lscp cannot be used when thermcep=false'
-     CALL abort_physic(modname,abort_message,1)
+IF (iflag_fisrtilp_qsat .LT. 0) THEN
+    abort_message = 'lscp cannot be used with iflag_fisrtilp<0'
+    CALL abort_physic(modname,abort_message,1)
 ENDIF
 
-IF (iflag_fisrtilp_qsat .LT. 0) THEN
-        abort_message = 'lscp cannot be used with iflag_fisrtilp<0'
-     CALL abort_physic(modname,abort_message,1)
-ENDIF
-
-
 ! Few initialisations
 
-itap=itap+1
-znebprecip(:)=0.
+znebprecip(:)=0.0
 ctot_vol(1:klon,1:klev)=0.0
 rneblsvol(1:klon,1:klev)=0.0
-smallestreal=1.e-9                                                                                  
-znebprecipclr(:)=0.    
-znebprecipcld(:)=0.                                                                            
+smallestreal=1.e-9
+znebprecipclr(:)=0.0
+znebprecipcld(:)=0.0
 mpc_bl_points(:,:)=0
 
 IF (prt_level>9) WRITE(lunout,*) 'NUAGES4 A. JAM'
-
-IF (appel1er) THEN
-    CALL getin_p('ninter',ninter)
-    CALL getin_p('iflag_evap_prec',iflag_evap_prec)
-    CALL getin_p('seuil_neb',seuil_neb)
-    CALL getin_p('rain_int_min',rain_int_min) 
-    WRITE(lunout,*) 'lscp, ninter:', ninter
-    WRITE(lunout,*) 'lscp, iflag_evap_prec:', iflag_evap_prec
-    WRITE(lunout,*) 'lscp, seuil_neb:', seuil_neb
-    WRITE(lunout,*) 'lscp, rain_int_min:', rain_int_min
-
-    ! check for precipitation sub-time steps
-    IF (ABS(dtime/REAL(ninter)-360.0).GT.0.001) THEN
-        WRITE(lunout,*) 'lscp: it is not expected, see Z.X.Li', dtime
-        WRITE(lunout,*) 'I would prefer a 6 min sub-timestep'
-    ENDIF
-     
-    !AA Temporary initialisation
-    a_tr_sca(1) = -0.5
-    a_tr_sca(2) = -0.5
-    a_tr_sca(3) = -0.5
-    a_tr_sca(4) = -0.5
-
-    !AA Set scavenged fractions to 1
-    DO k = 1, klev
-        DO i = 1, klon
-            pfrac_nucl(i,k)=1.
-            pfrac_1nucl(i,k)=1.
-            pfrac_impa(i,k)=1.
-            beta(i,k)=0.       
-        ENDDO
-    ENDDO
-
-    IF (ok_ice_sursat) CALL ice_sursat_init()
-
-    appel1er = .FALSE.
-
-ENDIF     !(appel1er)  
 
 ! AA for 'safety' reasons
 zalpha_tr   = 0.
 zfrac_lessi = 0.
-
-! Initialisation of output variables (JYG):
+beta(:,:)= 0.
+
+! Initialisation of variables:
+
 prfl(:,:) = 0.0
 psfl(:,:) = 0.0
-
 d_t(:,:) = 0.0
 d_q(:,:) = 0.0
@@ -377,9 +297,8 @@
 d_qi(:,:) = 0.0
 rneb(:,:) = 0.0
-radliq(:,:) = 0.0
+radocond(:,:) = 0.0
 radicefrac(:,:) = 0.0
-frac_nucl(:,:) = 1. 
-frac_impa(:,:) = 1. 
-
+frac_nucl(:,:) = 1.0 
+frac_impa(:,:) = 1.0 
 rain(:) = 0.0
 snow(:) = 0.0
@@ -393,17 +312,17 @@
 ziflprev(:)=0.0
 zneb(:) = seuil_neb
-zrflclr(:) = 0.0                                                                            
-ziflclr(:) = 0.0                                                                            
-zrflcld(:) = 0.0                                                                               
-ziflcld(:) = 0.0                                                                                  
-tot_zneb(:) = 0.0                                                                                 
-tot_znebn(:) = 0.0                                                                               
-d_tot_zneb(:) = 0.0   
-qzero(:)=0.0
-
-!--ice sursaturation
-gamma_ss(:,:) = 1.
-qss(:,:) = 0.
-rnebss(:,:) = 0.
+zrflclr(:) = 0.0
+ziflclr(:) = 0.0
+zrflcld(:) = 0.0
+ziflcld(:) = 0.0
+tot_zneb(:) = 0.0
+tot_znebn(:) = 0.0
+d_tot_zneb(:) = 0.0
+qzero(:) = 0.0
+
+!--ice supersaturation
+gamma_ss(:,:) = 1.0
+qss(:,:) = 0.0
+rnebss(:,:) = 0.0
 Tcontr(:,:) = missing_val
 qcontr(:,:) = missing_val
@@ -412,4 +331,7 @@
 fcontrP(:,:) = 0.0
 
+!c_iso: variable initialisation for iso 
+
+
 !===============================================================================
 !              BEGINNING OF VERTICAL LOOP FROM TOP TO BOTTOM
@@ -419,5 +341,4 @@
 
 DO k = klev, 1, -1
-
 
     ! Initialisation temperature and specific humidity
@@ -425,4 +346,5 @@
         zt(i)=t(i,k)
         zq(i)=q(i,k)
+        !c_iso init of iso
     ENDDO
     
@@ -430,14 +352,18 @@
     ! P0> Thermalization of precipitation falling from the overlying layer
     ! --------------------------------------------------------------------
-    ! Computes air temperature variation due to latent heat transported by
+    ! Computes air temperature variation due to enthalpy transported by
     ! precipitation. Precipitation is then thermalized with the air in the
     ! layer. 
     ! The precipitation should remain thermalized throughout the different
-    ! thermodynamical transformations. The corresponding water mass should
+    ! thermodynamical transformations. 
+    ! The corresponding water mass should
     ! be added when calculating the layer's enthalpy change with 
     ! temperature
+    ! See lmdzpedia page todoan
+    ! todoan: check consistency with ice phase
+    ! todoan: understand why several steps
     ! ---------------------------------------------------------------------
     
-    IF (k.LE.klevm1) THEN 
+    IF (k.LE.klev-1) THEN 
 
         DO i = 1, klon
@@ -447,6 +373,6 @@
             ! RVTMP2=rcpv/rcpd-1
             zcpair=RCPD*(1.0+RVTMP2*zq(i)) 
-            zcpeau=RCPD*RVTMP2             
-                                          
+            zcpeau=RCPD*RVTMP2
+
             ! zmqc: precipitation mass that has to be thermalized with 
             ! layer's air so that precipitation at the ground has the
@@ -456,8 +382,8 @@
             zt(i) = ( (t(i,k+1)+d_t(i,k+1))*zmqc(i)*zcpeau + zcpair*zt(i) ) &
              / (zcpair + zmqc(i)*zcpeau)
-           
+
         ENDDO
  
-    ELSE  
+    ELSE
  
         DO i = 1, klon 
@@ -474,25 +400,26 @@
     ! --------------------------------------------------------------------
 
-
-    IF (iflag_evap_prec.GE.1) THEN
+    IF (iflag_evap_prec.GE.1) THEN 
 
         ! Calculation of saturation specific humidity
         ! depending on temperature:
-        CALL CALC_QSAT_ECMWF(klon,zt(:),qzero(:),pplay(:,k),RTT,0,.false.,zqs(:),zdqs(:))
+        CALL calc_qsat_ecmwf(klon,zt(:),qzero(:),pplay(:,k),RTT,0,.false.,zqs(:),zdqs(:))
         ! wrt liquid water
-        CALL CALC_QSAT_ECMWF(klon,zt(:),qzero(:),pplay(:,k),RTT,1,.false.,qsl(:),dqsl(:))
+        CALL calc_qsat_ecmwf(klon,zt(:),qzero(:),pplay(:,k),RTT,1,.false.,qsl(:),dqsl(:))
         ! wrt ice
-        CALL CALC_QSAT_ECMWF(klon,zt(:),qzero(:),pplay(:,k),RTT,2,.false.,qsi(:),dqsi(:))
+        CALL calc_qsat_ecmwf(klon,zt(:),qzero(:),pplay(:,k),RTT,2,.false.,qsi(:),dqsi(:))
 
         DO i = 1, klon
-     
+
             ! if precipitation
             IF (zrfl(i)+zifl(i).GT.0.) THEN
-                    
-            ! LTP: we only account for precipitation evaporation in the clear-sky (iflag_evap_prec=4).
-                IF (iflag_evap_prec.EQ.4) THEN                                                          
-                    zrfl(i) = zrflclr(i)                                                          
-                    zifl(i) = ziflclr(i)                                                           
-                ENDIF                      
+
+            ! LudoTP: we only account for precipitation evaporation in the clear-sky (iflag_evap_prec=4).
+            ! c_iso: likely important to distinguish cs from neb isotope precipitation
+
+                IF (iflag_evap_prec.EQ.4) THEN
+                    zrfl(i) = zrflclr(i)
+                    zifl(i) = ziflclr(i)
+                ENDIF
 
                 IF (iflag_evap_prec.EQ.1) THEN
@@ -501,14 +428,12 @@
                     znebprecip(i)=MAX(zneb(i),znebprecip(i))
                 ENDIF
-     
-                                                                                                                                                                                                                  
-                IF (iflag_evap_prec.EQ.4) THEN                                                                 
-                ! Max evaporation not to saturate the whole mesh                                             
-                    zqev0 = MAX(0.0, zqs(i)-zq(i))                                                              
-                ELSE       
-                ! Max evap not to saturate the fraction below the cloud                                                   
-                    zqev0 = MAX(0.0, (zqs(i)-zq(i))*znebprecip(i))                                                                                  
-                ENDIF   
-
+
+                IF (iflag_evap_prec.EQ.4) THEN
+                ! Max evaporation not to saturate the whole mesh
+                    zqev0 = MAX(0.0, zqs(i)-zq(i))
+                ELSE
+                ! Max evap not to saturate the fraction below the cloud
+                    zqev0 = MAX(0.0, (zqs(i)-zq(i))*znebprecip(i))
+                ENDIF
 
                 ! Evaporation of liquid precipitation coming from above
@@ -530,8 +455,7 @@
                 ENDIF
 
-
                 zqevt = MAX(0.0,MIN(zqevt,zrfl(i))) &
-                *RG*dtime/(paprs(i,k)-paprs(i,k+1)) 
-         
+                    *RG*dtime/(paprs(i,k)-paprs(i,k+1)) 
+
                 ! sublimation of the solid precipitation coming from above
                 IF (iflag_evap_prec.EQ.3) THEN
@@ -547,7 +471,7 @@
                     *(paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
                 ENDIF
-            
+
                 zqevti = MAX(0.0,MIN(zqevti,zifl(i))) &
-                *RG*dtime/(paprs(i,k)-paprs(i,k+1))   
+                *RG*dtime/(paprs(i,k)-paprs(i,k+1))
 
                 ! A. JAM
@@ -556,5 +480,6 @@
                 ! does not reach saturation. In this case, we 
                 ! redistribute zqev0 conserving the ratio liquid/ice 
-   
+
+                ! todoan: check the consistency of this formula
                 IF (zqevt+zqevti.GT.zqev0) THEN
                     zqev=zqev0*zqevt/(zqevt+zqevti)
@@ -566,5 +491,5 @@
 
 
-                ! New solid and liquid precipitation fluxes
+                ! New solid and liquid precipitation fluxes after evap and sublimation
                 zrfln(i) = Max(0.,zrfl(i) - zqev*(paprs(i,k)-paprs(i,k+1))  &
                          /RG/dtime)
@@ -572,8 +497,8 @@
                          /RG/dtime)
 
+
                 ! vapor, temperature, precip fluxes update
                 zq(i) = zq(i) - (zrfln(i)+zifln(i)-zrfl(i)-zifl(i)) &
                 * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime
-                ! precip thermalization
                 zmqc(i) = zmqc(i) + (zrfln(i)+zifln(i)-zrfl(i)-zifl(i)) &
                 * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime
@@ -589,27 +514,43 @@
                 zifl(i) = zifln(i)
 
-                IF (iflag_evap_prec.EQ.4) THEN                                                                 
-                    zrflclr(i) = zrfl(i)                                                                  
-                    ziflclr(i) = zifl(i)    
-                    IF(zrflclr(i) + ziflclr(i).LE.0) THEN                                                
-                        znebprecipclr(i) = 0.                                                          
-                    ENDIF                                                                                
-                    zrfl(i) = zrflclr(i) + zrflcld(i)                                                      
-                    zifl(i) = ziflclr(i) + ziflcld(i)                                                      
-                ENDIF      
-
-
-                ! CR Be careful: ice melting has been moved
-                zmelt = ((zt(i)-273.15)/(ztfondue-273.15)) ! JYG
+                ! c_iso here call_reevap that updates isotopic zrfl, zifl (in inout)
+                !                         due to evap + sublim                                     
+                                           
+
+                IF (iflag_evap_prec.EQ.4) THEN
+                    zrflclr(i) = zrfl(i)
+                    ziflclr(i) = zifl(i)
+                    IF(zrflclr(i) + ziflclr(i).LE.0) THEN
+                        znebprecipclr(i) = 0.0
+                    ENDIF
+                    zrfl(i) = zrflclr(i) + zrflcld(i)
+                    zifl(i) = ziflclr(i) + ziflcld(i)
+                ENDIF
+
+                ! c_iso duplicate for isotopes or loop on isotopes
+
+                ! Melting:
+                zmelt = ((zt(i)-RTT)/(ztfondue-RTT)) ! JYG
                 ! precip fraction that is melted
                 zmelt = MIN(MAX(zmelt,0.),1.)
-                ! Ice melting
-                IF (iflag_evap_prec.EQ.4) THEN                                                              
-                    zrflclr(i)=zrflclr(i)+zmelt*ziflclr(i)                                            
-                    zrflcld(i)=zrflcld(i)+zmelt*ziflcld(i)                                              
-                    zrfl(i)=zrflclr(i)+zrflcld(i)                                                       
-                ELSE                                                                                        
-                    zrfl(i)=zrfl(i)+zmelt*zifl(i)                                                      
-                ENDIF                  
+
+                ! update of rainfall and snowfall due to melting
+                IF (iflag_evap_prec.EQ.4) THEN
+                    zrflclr(i)=zrflclr(i)+zmelt*ziflclr(i)
+                    zrflcld(i)=zrflcld(i)+zmelt*ziflcld(i)
+                    zrfl(i)=zrflclr(i)+zrflcld(i)
+
+                    ziflclr(i)=ziflclr(i)*(1.-zmelt)
+                    ziflcld(i)=ziflcld(i)*(1.-zmelt)
+                    zifl(i)=ziflclr(i)+ziflcld(i)
+
+                ELSE
+                    zrfl(i)=zrfl(i)+zmelt*zifl(i)
+
+                    zifl(i)=zifl(i)*(1.-zmelt)
+                ENDIF
+
+
+                ! c_iso: melting of isotopic precipi with zmelt (no fractionation)
 
                 ! Latent heat of melting with precipitation thermalization
@@ -617,11 +558,4 @@
                 *RLMLT/RCPD/(1.0+RVTMP2*(zq(i)+zmqc(i)))
                 
-                IF (iflag_evap_prec.EQ.4) THEN                                                             
-                    ziflclr(i)=ziflclr(i)*(1.-zmelt)                                                    
-                    ziflcld(i)=ziflcld(i)*(1.-zmelt)                                                    
-                    zifl(i)=ziflclr(i)+ziflcld(i)                                                       
-                ELSE                                                                                      
-                    zifl(i)=zifl(i)*(1.-zmelt)                                                          
-                ENDIF
 
             ELSE
@@ -632,5 +566,5 @@
 
         ENDDO
-         
+
     ENDIF ! (iflag_evap_prec>=1)
 
@@ -638,13 +572,10 @@
     ! End precip evaporation
     ! --------------------------------------------------------------------
-
-
-
     
     ! Calculation of qsat, L/Cp*dqsat/dT and ncoreczq counter
     !-------------------------------------------------------
-      
+
      qtot(:)=zq(:)+zmqc(:)
-     CALL CALC_QSAT_ECMWF(klon,zt(:),qtot(:),pplay(:,k),RTT,0,.false.,zqs(:),zdqs(:))
+     CALL calc_qsat_ecmwf(klon,zt(:),qtot(:),pplay(:,k),RTT,0,.false.,zqs(:),zdqs(:))
      DO i = 1, klon
             zdelta = MAX(0.,SIGN(1.,RTT-zt(i)))
